package net.sf.itcb.common.server.batch;

import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * This main class load application context from files that match this pattern classpath*:spring/"+ System.getenv("itcb.env") + "/*-applicationContext-hosts.xml", "classpath*:spring/*-applicationContext.xml", "classpath*:spring/batch/"+ System.getenv("itcb.env") + "/*-applicationContext-hosts.xml", "classpath*:spring/batch/*-applicationContext.xml"
 * then call run method of itcbCommonBatch bean declared in context.
 * 
 * You can call another bean run method by calling the process with bean name as argument
 * @author Pierre Le Roux
 *
 * @see ItcbCommonBatch
 */
public class MainBatch {
	
	
	public static ClassPathXmlApplicationContext loadBatchApplicationContext(String env) {

		return new ClassPathXmlApplicationContext(
		        new String[] {"classpath*:spring/"+ env + "/*-applicationContext-hosts.xml", "classpath*:spring/*-applicationContext.xml", "classpath*:spring/batch/"+ env + "/*-applicationContext-hosts.xml", "classpath*:spring/batch/*-applicationContext.xml"});
		
	}

	public static void main(String[] args) {
		System.out.println("Itcb.env : " + System.getenv("itcb.env"));
		ClassPathXmlApplicationContext appContext = loadBatchApplicationContext(System.getenv("itcb.env"));
		ItcbCommonBatch itcbCommonBatch; 
		if(args.length > 0) {
			itcbCommonBatch= appContext.getBean(args[0], ItcbCommonBatch.class);
		}
		else {
			itcbCommonBatch= appContext.getBean("itcbCommonBatch", ItcbCommonBatch.class);
		}
		itcbCommonBatch.run();
	}
}
